/**
 * PETALS - PETALS Services Platform. Copyright (c) 2006 EBM Websourcing,
 * http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.se.xslt;

import java.io.ByteArrayOutputStream;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Templates;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.URIResolver;
import javax.xml.transform.stream.StreamResult;

/**
 * @author alouis, ofabre, cgirodengo
 * 
 */
public class XsltImpl implements Xslt {

    /**
     * Creates a new instance of {@link XsltImpl}
     * 
     */
    public XsltImpl() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.ow2.petals.se.xslt.Xslt#transform(javax.xml.transform.Source,
     * javax.xml.transform.Templates)
     */
    public ByteArrayOutputStream transform(Source xml, Templates xslTemplates, String installRoot) {
        try {
            Transformer transformer = xslTemplates.newTransformer();
            //TODO : the URIResolver objects must be cached as well as the xslTemplates
            URIResolver uriResolver = new ServiceUnitURIResolver(installRoot);
            transformer.setURIResolver(uriResolver);
            ByteArrayOutputStream outputStream = transformSource(xml, transformer);
            return outputStream;
        } catch (TransformerConfigurationException e) {
            throw new RuntimeException("Can't create XSL transformer - "
                    + e.getClass().getSimpleName() + " - " + e.getMessage());
        } catch (TransformerException e) {
            throw new RuntimeException(
                    "Can't transform XML content with the configured xsl sheet - "
                            + e.getClass().getSimpleName() + " - " + e.getMessage());
        }
    }

    /**
     * 
     * @param xml
     * @param transformer
     * @return
     * @throws TransformerException
     */
    private ByteArrayOutputStream transformSource(Source xml, Transformer transformer)
            throws TransformerException {
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        Result streamResult = new StreamResult(outputStream);
        transformer.transform(xml, streamResult);
        return outputStream;
    }

}
